//Erik Hanley
//David Dempsey
//Final project
package com.example.minermonsters;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.Writer;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class ScanActivity extends Activity {
	
	
	private static final String DEBUG_TAG = "MySimpleAppLogging";
	
	public static final String SLOTONE = "slot one";
	public static final String SLOTTWO = "slot two";
	public static final String NAME = "name";
	public static final String TYPE = "type";
	public static final String HP = "hp";
	public static final String STR = "str";
	public static final String DEF = "def";
	public static final String SPD = "spd";
	public static final String EXP = "exp";
	public static final String LEVEL = "lvl";
	public static final String SLOT = "slot";
	public static final String ELE = "ele";
	public static final String ELEMENT = "element";

	int location =0, mSlot;
	Scan scan = new Scan();
	Monster m;
	Inventory i = new Inventory();
	String mName;
	InputStream in;
	Writer out;

	boolean monsterFound;
	
	public SharedPreferences card1;
	public SharedPreferences card2;
	
	
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_scan);

		/* Use the LocationManager class to obtain GPS locations */
		//LocationManager mlocManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
		//LocationListener mlocListener = new MyLocationListener();
		//mlocManager.requestLocationUpdates( LocationManager.GPS_PROVIDER, 0, 0, mlocListener);

		monsterFound = false;
		
		Button btn = (Button)findViewById(R.id.scanButton1);
		
		final Button card1Btn = (Button) findViewById(R.id.card1_btn);
        final Button card2Btn = (Button) findViewById(R.id.card2_btn);
        final Button backBtn = (Button) findViewById(R.id.back_btn);
		
		final TextView name_text = (TextView) findViewById(R.id.name_text);
        final TextView Element_text = (TextView) findViewById(R.id.Element_text);
        final TextView hp_text = (TextView) findViewById(R.id.hp_text);
        final TextView lvl_text = (TextView) findViewById(R.id.lvl_text);
        final TextView exp_text = (TextView) findViewById(R.id.exp_text);
        final TextView spd_text = (TextView) findViewById(R.id.spd_text);
        final TextView def_text = (TextView) findViewById(R.id.def_text);
        final TextView str_text = (TextView) findViewById(R.id.str_text);
        final TextView element_text = (TextView) findViewById(R.id.element_text);
        
        final ImageView monsterImage = (ImageView) findViewById(R.id.scanImage);
        final EditText nameEditText = (EditText) findViewById(R.id.name_editText);
        
        card1Btn.setVisibility(8);
    	card2Btn.setVisibility(8);
    	
    	nameEditText.setVisibility(8);
        monsterImage.setVisibility(8);
        Element_text.setVisibility(8);
    	hp_text.setVisibility(8);
    	str_text.setVisibility(8);
    	def_text.setVisibility(8);
    	element_text.setVisibility(8);
    	exp_text.setVisibility(8);
    	lvl_text.setVisibility(8);
    	spd_text.setVisibility(8);
    	card1Btn.setClickable(false);
    	card2Btn.setClickable(false);
    	name_text.setVisibility(8);
    	backBtn.setText("back");

		

		btn.setOnClickListener(new View.OnClickListener() {


			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				LocationManager mlocManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
				LocationListener mlocListener = new MyLocationListener();
				mlocManager.requestLocationUpdates( LocationManager.GPS_PROVIDER, 0, 0, mlocListener);

				if(location == 0)
				{

						Toast.makeText( getApplicationContext(),"Invalid Location",Toast.LENGTH_SHORT ).show();
					}
					else
					{
						Toast.makeText( getApplicationContext(),"Monster Found!",Toast.LENGTH_LONG ).show();
						m = scan.scanMonster(location);
						
						
						Button scanBtn = (Button)findViewById(R.id.scanButton1);
						scanBtn.setVisibility(8);
						
						card1Btn.setClickable(true);
				    	card2Btn.setClickable(true);
				    	backBtn.setClickable(true);
				    	
				    	backBtn.setText("Delete");
			        	
				    	Element_text.setText("Type: " + m.getType());
			        	hp_text.setText("HP: " + m.getHp());
			        	str_text.setText("Strenth: " + m.getStr());
			        	exp_text.setText("Exp: " + m.getExp());
			        	def_text.setText("Defense: " + m.getDef());
			        	lvl_text.setText("Level: " + m.getLvl());
			        	spd_text.setText("Speed: " + m.getSpd());
			        	element_text.setText("Element: " + m.getElement());
			        	
			        	
			        	switch(m.getType())
			            {
			            case 1:
			            	monsterImage.setImageResource(R.drawable.firestr);
			            	break;
			            case 2:
			            	monsterImage.setImageResource(R.drawable.firedef);
			            	break;
			            case 3:
			            	monsterImage.setImageResource(R.drawable.firespd);
			            	break;
			            case 4:
			            	monsterImage.setImageResource(R.drawable.icestr);
			            	break;
			            case 5:
			            	monsterImage.setImageResource(R.drawable.icedef);
			            	break;
			            case 6:
			            	monsterImage.setImageResource(R.drawable.icespd);
			            	break;
			            case 7:
			            	monsterImage.setImageResource(R.drawable.elecstr);
			            	break;
			            case 8:
			            	monsterImage.setImageResource(R.drawable.elecdef);
			            	break;
			            case 9:
			            	monsterImage.setImageResource(R.drawable.elecspd);
			            	break;
			            }
			        	
			        	
			        	card1Btn.setVisibility(0);
			        	card2Btn.setVisibility(0);
			        	
			        	name_text.setVisibility(0);
			        	Element_text.setVisibility(0);
			        	hp_text.setVisibility(0);
			        	str_text.setVisibility(0);
			        	def_text.setVisibility(0);
			        	
			        	element_text.setVisibility(0);
			        	lvl_text.setVisibility(0);
			        	exp_text.setVisibility(0);
			        	spd_text.setVisibility(0);
			        	
			        	
				        monsterImage.setVisibility(0);
						
						
			        	nameEditText.setVisibility(0);
					}
				}

			
		});

		card1 =  getSharedPreferences("com.example.minermonsters.savedstate1", Activity.MODE_PRIVATE);
        card2 =  getSharedPreferences("com.example.minermonsters.savedstate2", Activity.MODE_PRIVATE);
		
		final Editor card1PrivateEditor = card1.edit();
		final Editor card2PrivateEditor = card2.edit();

		card1Btn.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				m.setName(nameEditText.getText().toString());
				card1PrivateEditor.putString(NAME, m.getName());
				card1PrivateEditor.putString(TYPE, Integer.toString(m.getType()));
				card1PrivateEditor.putString(HP, Integer.toString(m.getHp()));
				
				card1PrivateEditor.putString(STR, Integer.toString(m.getStr()));
				card1PrivateEditor.putString(DEF, Integer.toString(m.getDef()));
				card1PrivateEditor.putString(SPD, Integer.toString(m.getSpd()));
				
				card1PrivateEditor.putString(EXP, Integer.toString(m.getExp()));
				card1PrivateEditor.putString(LEVEL, Integer.toString(m.getLvl()));
				
				card1PrivateEditor.putString(ELE, Integer.toString(m.getEle()));
				card1PrivateEditor.putString(ELEMENT, m.getElement());
				
				card1PrivateEditor.putString(SLOT, Integer.toString(1));
				
				card1PrivateEditor.commit();
				
				Toast.makeText( getApplicationContext(),"Saved to Card One",Toast.LENGTH_LONG ).show();
				finish();

			}
		});
		
		card2Btn.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				m.setName(nameEditText.getText().toString());
				card2PrivateEditor.putString(NAME, m.getName());
				card2PrivateEditor.putString(TYPE, Integer.toString(m.getType()));
				card2PrivateEditor.putString(HP, Integer.toString(m.getHp()));
				
				card2PrivateEditor.putString(STR, Integer.toString(m.getStr()));
				card2PrivateEditor.putString(DEF, Integer.toString(m.getDef()));
				card2PrivateEditor.putString(SPD, Integer.toString(m.getSpd()));
				
				card2PrivateEditor.putString(EXP, Integer.toString(m.getExp()));
				card2PrivateEditor.putString(LEVEL, Integer.toString(m.getLvl()));
				
				card2PrivateEditor.putString(ELE, Integer.toString(m.getEle()));
				card2PrivateEditor.putString(ELEMENT, m.getElement());
				
				card2PrivateEditor.putString(SLOT, Integer.toString(2));
				
				card2PrivateEditor.commit();
				
				Toast.makeText( getApplicationContext(),"Saved to Card Two",Toast.LENGTH_LONG ).show();
				finish();
			}
		});
		
		
		backBtn.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				finish();
				
			}
		});
		
	}
	/* Class My Location Listener */
	public class MyLocationListener implements LocationListener
	{
		@Override
		public void onLocationChanged(Location loc)
		{
			
			double lat = loc.getLatitude();
			double lon = loc.getLongitude();
			
			//Toast.makeText( getApplicationContext(), "Lat="+lat, Toast.LENGTH_SHORT ).show();
			//Toast.makeText( getApplicationContext(), "Lon="+lon, Toast.LENGTH_SHORT ).show();

			if(lat < 35.3085 && lat > 35.3065)
			{
				if(lon > -80.737 && lon < -80.735)
				{
					location =1;
				}
				if(lon > -80.735 && lon< -80.732)
				{
					location =2;
				}
				if(lon > -80.732 && lon < -80.729)
				{
					location =3;
				}
			}
			if(lat < 35.307 && lat > 35.3055)
			{
				if(lon > -80.737 && lon < -80.735)
				{
					location =4;
				}
				if(lon > -80.735 && lon< -80.732)
				{
					location =5;
				}
				if(lon > -80.732 && lon < -80.729)
				{
					location =6;
				}
			}
			if(lat < 35.3055 && lat > 35.3036)
			{
				if(lon > -80.737 && lon < -80.735)
				{
					location =7;
				}
				if(lon > -80.735 && lon< -80.732)
				{
					location =8;
				}
				if(lon > -80.732 && lon < -80.729)
				{
					location =9;
				}
			}
			//Toast.makeText( getApplicationContext(), "Location="+location, Toast.LENGTH_SHORT ).show();
		}

		@Override
		public void onProviderDisabled(String provider)
		{
			Toast.makeText( getApplicationContext(),
					"Gps Disabled",
					Toast.LENGTH_SHORT ).show();
		}

		@Override
		public void onProviderEnabled(String provider)
		{
			Toast.makeText( getApplicationContext(),
					"Gps Enabled",
					Toast.LENGTH_SHORT).show();
		}

		@Override
		public void onStatusChanged(String provider, int status, Bundle extras)
		{

		}

	}
}
