//Erik Hanley
//David Dempsey
//Final project
package com.example.minermonsters;


import java.util.Random;

import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.util.*;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.PopupMenu;
import android.widget.PopupMenu.OnMenuItemClickListener;
import android.widget.TextView;
import android.content.SharedPreferences.Editor;
import android.widget.Toast;

public class SinglePlayerActivity extends Activity {
	Random rand = new Random();
	private int randy, choice;
	private long startTime = 0;
	private long delay = 1000;
	public SharedPreferences card1;
	public SharedPreferences card2;
	
	public static final String SLOTONE = "slot one";
	public static final String SLOTTWO = "slot two";
	public static final String NAME = "name";
	public static final String TYPE = "type";
	public static final String HP = "hp";
	public static final String STR = "str";
	public static final String DEF = "def";
	public static final String SPD = "spd";
	public static final String EXP = "exp";
	public static final String LEVEL = "lvl";
	public static final String ELE = "ele";
	public static final String ELEMENT = "element";
	public static final String SLOT = "slot";
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_single_player);
		
		Intent intent = getIntent();

		choice = intent.getIntExtra("monsterChoice", 1);

		card1 =  getSharedPreferences("com.example.minermonsters.savedstate1", Activity.MODE_PRIVATE);
        card2 =  getSharedPreferences("com.example.minermonsters.savedstate2", Activity.MODE_PRIVATE);
		
		final Editor card1PrivateEditor = card1.edit();
		final Editor card2PrivateEditor = card2.edit();

		String type ="", hp="", str="", def="", spd="", exp="", lvl="", ele="", name="";
		int slot=0;
		final Monster m1, m2;
		final Battle battle;

		final ImageView p1Image = (ImageView) findViewById(R.id.p1Image);
		final ImageView p2Image = (ImageView) findViewById(R.id.p2Image);
		final TextView p1Name = (TextView) findViewById(R.id.p1Name);
		final TextView p1Hp = (TextView) findViewById(R.id.p1Hp);
		final TextView p2Name = (TextView) findViewById(R.id.p2Name);
		final TextView p2Hp = (TextView) findViewById(R.id.p2Hp);
		final TextView p1Lvl = (TextView) findViewById(R.id.p1Level);
		final TextView p2Lvl = (TextView) findViewById(R.id.p2Level);
		final TextView bText = (TextView) findViewById(R.id.battleText);
		final TextView bText2 = (TextView) findViewById(R.id.battleText2);
		bText.setText("");
		bText2.setText("");

		Button b1 = (Button) findViewById(R.id.attackButton);
		
		if(choice == 1)
		{
			if(Integer.valueOf(card1.getString(TYPE, "0"))==0)
			{
				Toast.makeText(getBaseContext(),"No monster in slot 1" , Toast.LENGTH_LONG).show();
				finish();
				return;
			}
			else
			{
				type = card1.getString(TYPE, "0");
				hp = card1.getString(HP, "0");
				str = card1.getString(STR, "0");
				def = card1.getString(DEF, "0");
				spd = card1.getString(SPD, "0");
				exp = card1.getString(EXP, "0");
				lvl = card1.getString(LEVEL, "0");
				ele = card1.getString(ELE, "0");
				name = card1.getString(NAME, "0");
				slot =1;
				
				
			}
		}
		else
		{
			if(Integer.valueOf(card2.getString(TYPE, "0"))==0)
			{
				Toast.makeText(getBaseContext(),"No monster in slot 2" , Toast.LENGTH_LONG).show();
				finish();
				return;
			}
			else
			{
				type = card2.getString(TYPE, "0");
				hp = card2.getString(HP, "0");
				str = card2.getString(STR, "0");
				def = card2.getString(DEF, "0");
				spd = card2.getString(SPD, "0");
				exp = card2.getString(EXP, "0");
				lvl = card2.getString(LEVEL, "0");
				ele = card2.getString(ELE, "0");
				name = card2.getString(NAME, "0");
				slot =1;
				
				
			}
		}
		m1 = new Monster(type, hp, str, def, spd, exp, lvl, slot, ele, name);

		//        if(!card1.getString("type", "NA").equals("NA")){
		//			type = card1.getString("type", "NA");
		//			hp = card1.getString("hp", "NA");
		//			str = card1.getString("str", "NA");
		//			def = card1.getString("def", "NA");
		//			spd = card1.getString("spd", "NA");
		//			exp = card1.getString("exp", "NA");
		//			lvl = card1.getString("lvl", "NA");
		//			ele = card1.getString("ele", "NA");
		//			name = card1.getString("name", "NA");
		//			m1 = new Monster(type, hp, str, def, spd, exp, lvl, 1, ele, name);
		//        }
		

		//randy = rand.nextInt(9) +1;
//		m1 = new Monster(choice);
//		m1.setName("Your Monster" + choice);
		m1.checkExp();
		randy = rand.nextInt(9) +1;
		m2 = new Monster(randy);
		m2.gainExp(m1.getExp());
		m2.checkExp();
		m2.setName("Enemy Monster");

		switch(m1.getType())
		{
		case 1:
			p1Image.setImageResource(R.drawable.firestr);
			break;
		case 2:
			p1Image.setImageResource(R.drawable.firedef);
			break;
		case 3:
			p1Image.setImageResource(R.drawable.firespd);
			break;
		case 4:
			p1Image.setImageResource(R.drawable.icestr);
			break;
		case 5:
			p1Image.setImageResource(R.drawable.icedef);
			break;
		case 6:
			p1Image.setImageResource(R.drawable.icespd);
			break;
		case 7:
			p1Image.setImageResource(R.drawable.elecstr);
			break;
		case 8:
			p1Image.setImageResource(R.drawable.elecdef);
			break;
		case 9:
			p1Image.setImageResource(R.drawable.elecspd);
			break;
		}

		switch(m2.getType())
		{
		case 1:
			p2Image.setImageResource(R.drawable.firestr);
			break;
		case 2:
			p2Image.setImageResource(R.drawable.firedef);
			break;
		case 3:
			p2Image.setImageResource(R.drawable.firespd);
			break;
		case 4:
			p2Image.setImageResource(R.drawable.icestr);
			break;
		case 5:
			p2Image.setImageResource(R.drawable.icedef);
			break;
		case 6:
			p2Image.setImageResource(R.drawable.icespd);
			break;
		case 7:
			p2Image.setImageResource(R.drawable.elecstr);
			break;
		case 8:
			p2Image.setImageResource(R.drawable.elecdef);
			break;
		case 9:
			p2Image.setImageResource(R.drawable.elecspd);
			break;
		}

		p1Name.setText(m1.getName());
		p2Name.setText(m2.getName());
		p1Lvl.setText("Level: "+ m1.getLvl());
		p2Lvl.setText("Level: "+ m2.getLvl());
		battle = new Battle(m1,m2);
		p1Hp.setText("Life: " +battle.getM1hp()+ "/"+m1.getHp());
		p2Hp.setText("Life: " +battle.getM2hp()+ "/"+m2.getHp());

		b1.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {

				double factor;
				int xp;

				battle.firstAttack();
				p1Hp.setText("Life: " +battle.getM1hp()+ "/"+m1.getHp());
				p2Hp.setText("Life: " +battle.getM2hp()+ "/"+m2.getHp());
				if(battle.getFirstGo() == 1)
				{
					bText.setText(m1.getName() + " deals " + battle.getM1Damage() + " damage!");

				}
				else
				{
					bText.setText(m2.getName() + " deals " + battle.getM2Damage() + " damage!");
				}
			

				if(battle.getM1hp() <= 0)
				{
					if(m2.getLvl() != 5)
					{
						factor = (double)m1.getLvl()/m2.getLvl();
						xp = (int)((factor)*m1.getHp());
						m2.gainExp(xp);
						m2.checkExp();
						Toast.makeText(getBaseContext(),"You lose!", Toast.LENGTH_LONG).show();
					}
				
					finish();
					return;
				}
				if(battle.getM2hp() <= 0)
				{
					if(m1.getLvl() != 5)
					{
						factor = (double)m2.getLvl()/m1.getLvl();
						xp = (int)((factor)*m2.getHp());
						m1.gainExp(xp);
						m1.checkExp();
						Toast.makeText(getBaseContext(), m1.getName()+" Wins!\nGained " +xp+" Xp.", Toast.LENGTH_LONG).show();
					}
					//need save here
					if(choice == 1)
					{
						card1PrivateEditor.putString(NAME, m1.getName());
						card1PrivateEditor.putString(TYPE, Integer.toString(m1.getType()));
						card1PrivateEditor.putString(HP, Integer.toString(m1.getHp()));
						
						card1PrivateEditor.putString(STR, Integer.toString(m1.getStr()));
						card1PrivateEditor.putString(DEF, Integer.toString(m1.getDef()));
						card1PrivateEditor.putString(SPD, Integer.toString(m1.getSpd()));
						
						card1PrivateEditor.putString(EXP, Integer.toString(m1.getExp()));
						card1PrivateEditor.putString(LEVEL, Integer.toString(m1.getLvl()));
						
						card1PrivateEditor.putString(ELE, Integer.toString(m1.getEle()));
						card1PrivateEditor.putString(ELEMENT, m1.getElement());
						
						card1PrivateEditor.putString(SLOT, Integer.toString(choice));
						
						card1PrivateEditor.commit();
					}
					else
					{
						card2PrivateEditor.putString(NAME, m1.getName());
						card2PrivateEditor.putString(TYPE, Integer.toString(m1.getType()));
						card2PrivateEditor.putString(HP, Integer.toString(m1.getHp()));
						
						card2PrivateEditor.putString(STR, Integer.toString(m1.getStr()));
						card2PrivateEditor.putString(DEF, Integer.toString(m1.getDef()));
						card2PrivateEditor.putString(SPD, Integer.toString(m1.getSpd()));
						
						card2PrivateEditor.putString(EXP, Integer.toString(m1.getExp()));
						card2PrivateEditor.putString(LEVEL, Integer.toString(m1.getLvl()));
						
						card2PrivateEditor.putString(ELE, Integer.toString(m1.getEle()));
						card2PrivateEditor.putString(ELEMENT, m1.getElement());
						
						card2PrivateEditor.putString(SLOT, Integer.toString(choice));
						
						card2PrivateEditor.commit();
					}
					finish();
					return;
				}
				

				battle.secondAttack();
				p1Hp.setText("Life: " +battle.getM1hp()+ "/"+m1.getHp());
				p2Hp.setText("Life: " +battle.getM2hp()+ "/"+m2.getHp());

				if(battle.getFirstGo() != 1)
				{
					bText2.setText(m1.getName() + " deals " + battle.getM1Damage() + " damage!");
				}
				else
				{
					bText2.setText(m2.getName() + " deals " + battle.getM2Damage() + " damage!");
				}

				if(battle.getM1hp() <= 0)
				{
					if(m2.getLvl() != 5)
					{
						factor = (double)m1.getLvl()/m2.getLvl();
						xp = (int)((factor)*m1.getHp());
						m2.gainExp(xp);
						m2.checkExp();
						Toast.makeText(getBaseContext(),"You lose!", Toast.LENGTH_LONG).show();
					}
					finish();
					return;
				}
				if(battle.getM2hp() <= 0)
				{
					if(m1.getLvl() != 5)
					{
						factor = (double)m2.getLvl()/m1.getLvl();
						xp = (int)((factor)*m2.getHp());
						m1.gainExp(xp);
						m1.checkExp();
						Toast.makeText(getBaseContext(), m1.getName()+" Wins!\nGained " +xp+" Xp.", Toast.LENGTH_LONG).show();
					}
					//need save here
					if(choice == 1)
					{
						card1PrivateEditor.putString(NAME, m1.getName());
						card1PrivateEditor.putString(TYPE, Integer.toString(m1.getType()));
						card1PrivateEditor.putString(HP, Integer.toString(m1.getHp()));
						
						card1PrivateEditor.putString(STR, Integer.toString(m1.getStr()));
						card1PrivateEditor.putString(DEF, Integer.toString(m1.getDef()));
						card1PrivateEditor.putString(SPD, Integer.toString(m1.getSpd()));
						
						card1PrivateEditor.putString(EXP, Integer.toString(m1.getExp()));
						card1PrivateEditor.putString(LEVEL, Integer.toString(m1.getLvl()));
						
						card1PrivateEditor.putString(ELE, Integer.toString(m1.getEle()));
						card1PrivateEditor.putString(ELEMENT, m1.getElement());
						
						card1PrivateEditor.putString(SLOT, Integer.toString(choice));
						
						card1PrivateEditor.commit();
					}
					else
					{
						card2PrivateEditor.putString(NAME, m1.getName());
						card2PrivateEditor.putString(TYPE, Integer.toString(m1.getType()));
						card2PrivateEditor.putString(HP, Integer.toString(m1.getHp()));
						
						card2PrivateEditor.putString(STR, Integer.toString(m1.getStr()));
						card2PrivateEditor.putString(DEF, Integer.toString(m1.getDef()));
						card2PrivateEditor.putString(SPD, Integer.toString(m1.getSpd()));
						
						card2PrivateEditor.putString(EXP, Integer.toString(m1.getExp()));
						card2PrivateEditor.putString(LEVEL, Integer.toString(m1.getLvl()));
						
						card2PrivateEditor.putString(ELE, Integer.toString(m1.getEle()));
						card2PrivateEditor.putString(ELEMENT, m1.getElement());
						
						card2PrivateEditor.putString(SLOT, Integer.toString(choice));
						
						card2PrivateEditor.commit();
					}
					finish();
					return;
				}
			}	
		});
	}
	



	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_single_player, menu);
		return true;
	}
}
